/*
 *  data.c
 *  
 *  Created by Jordan Frank on Thu December 7 2006.
 *
 *  Description: 
 *  
 *	Data collection routines for RecAgent.
 *
 */

#include "data.h"

void printMus()
{
    int res = 100;
    double mu;
    FILE *ft;
    char buf[100];
    int i,j;
    Observation o = new double[stateDim];
    int features[tilings];

    ft = fopen("Data/mus.dat","w");
    for (i=0; i <= res; i++) 
    {
        for (j=0; j <= res; j++)
        {
            o[0] = (float)i/(float)res;
            o[1] = (float)j/(float)res;
            getFeatureVector(o, features);
            mu = getMu(features);
            sprintf(buf,"%lf,%lf,%lf\n",o[0],o[1],mu);
            fputs(buf,ft);
        }
    }
    fclose(ft);
}

void printRew()
{
    int res = 100;
    double rew;
    FILE *ft1, *ft2;
    char buf[100];
    int i,j;
    Observation o = new double[stateDim];
    int features[tilings];

    ft1 = fopen("Data/Rewards.dat","w");
    ft2 = fopen("Data/Rewards-non-est.dat","w");
    for (i=0; i <= res; i++) 
    {
        for (j=0; j <= res; j++)
        {
            o[0] = (float)i/(float)res;
            o[1] = (float)j/(float)res;
            getFeatureVector(o, features);
            rew = vecvecMult(features,theta,tilings);
            sprintf(buf,"%lf,%lf,%lf\n",o[0],o[1],rew);
            fputs(buf,ft1);
            rew = vecvecMult(features,non_rec_theta,tilings);
            sprintf(buf,"%lf,%lf,%lf\n",o[0],o[1],rew);
            fputs(buf,ft2);
            
        }
    }
    fclose(ft1);
    fclose(ft2);
}

void openRecProbFiles()
{
    frec1 = fopen("Data/RecProbs1.dat","w");
    frec2 = fopen("Data/RecProbs2.dat","w");
    frec3 = fopen("Data/RecProbs3.dat","w");
    frec4 = fopen("Data/RecProbs4.dat","w");
}

void closeRecProbFiles()
{
    fclose(frec1);
    fclose(frec2);
    fclose(frec3);
    fclose(frec4);
}

void openRewEstFiles()
{
    frew1 = fopen("Data/RewEst1.dat","w");
    frew2 = fopen("Data/RewEst1-non-est.dat","w");
    frew3 = fopen("Data/RewEst2.dat","w");
    frew4 = fopen("Data/RewEst2-non-est.dat","w");
    frew5 = fopen("Data/RewEst3.dat","w");
    frew6 = fopen("Data/RewEst3-non-est.dat","w");
    frew7 = fopen("Data/RewEst4.dat","w");
    frew8 = fopen("Data/RewEst4-non-est.dat","w");
}

void closeRewEstFiles()
{
    fclose(frew1);
    fclose(frew2);
    fclose(frew3);
    fclose(frew4);
    fclose(frew5);
    fclose(frew6);
    fclose(frew7);
    fclose(frew8);
}


void printRecProbs()
{
    double xy[2];
    double mu;
    int fvec[tilings];
    char buf[100];
    
    xy[0] = 0.1;
    xy[1] = 0.1;
    getFeatureVector(xy,fvec);
    mu = getMu(fvec);
    sprintf(buf,"%f\n",mu);
    fputs(buf,frec1);

    xy[0] = 0.79;
    xy[1] = 0.79;
    getFeatureVector(xy,fvec);
    mu = getMu(fvec);
    sprintf(buf,"%f\n",mu);
    fputs(buf,frec2);

    xy[0] = 0.4;
    xy[1] = 0.7;
    getFeatureVector(xy,fvec);
    mu = getMu(fvec);
    sprintf(buf,"%f\n",mu);
    fputs(buf,frec3);

    xy[0] = 0.9;
    xy[1] = 0.1;
    getFeatureVector(xy,fvec);
    mu = getMu(fvec);
    sprintf(buf,"%f\n",mu);
    fputs(buf,frec4);
}

void printRewEst()
{
    double xy[2];
    double rew;
    int fvec[tilings];
    char buf[100];
    
    xy[0] = 0.1;
    xy[1] = 0.1;
    getFeatureVector(xy,fvec);
    rew = vecvecMult(fvec,theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew1);
    rew = vecvecMult(fvec,non_rec_theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew2);

    xy[0] = 0.79;
    xy[1] = 0.79;
    getFeatureVector(xy,fvec);
    rew = vecvecMult(fvec,theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew3);
    rew = vecvecMult(fvec,non_rec_theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew4);

    xy[0] = 0.4;
    xy[1] = 0.7;
    getFeatureVector(xy,fvec);
    rew = vecvecMult(fvec,theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew5);
    rew = vecvecMult(fvec,non_rec_theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew6);

    xy[0] = 0.9;
    xy[1] = 0.1;
    getFeatureVector(xy,fvec);
    rew = vecvecMult(fvec,theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew7);
    rew = vecvecMult(fvec,non_rec_theta,tilings);
    sprintf(buf,"%f\n",rew);
    fputs(buf,frew8);
}
