//Must include all the following files
#include "RL_Interface.h"
#include "gnu.h"
#include "RL_util.h"
#include <time.h>
#include <stdio.h>

/*********************************************************************************
 *	Benchmark driver program. 
 *
 *	Completely defines the experimental setup of the benchmark. Mostly format
 *	episodic/continuing, online/batch/train&test.
 *
 *	TEMPLATE
 *********************************************************************************/
time_t start;
time_t stop;
FILE *ft;
extern Observation current_state;
const int T = 100000;

//Method runs an experiment
void run(int num_steps)
{     
    int i;
  
    RL_start();   
    fflush(stdout);
    collectStatsCont();	 //collect stats
//    sprintf(buf,"%lf,%lf\n",current_state[0], current_state[1]);
//    fputs(buf,ft);

    for (i=1; i < num_steps; i++) {
        RL_step();
        // printf(".");
        fflush(stdout);
        collectStatsCont();	 //collect stats
//        sprintf(buf,"%lf,%lf\n",current_state[0], current_state[1]);
//        fputs(buf,ft);
    }
}

void startTimer(time_t *strt)
{
    time(strt);
}


void endTimer(time_t *stp)
{
    time(stp);
}


void printTimeTaken()
{
    int time = (int)(stop - start);
    printf("\nTIMING STATS::");
    printf("\n**************************************************************\n");
    printf("Time taken to complete the run: %d seconds\n",time);
    printf("**************************************************************\n");
}

//MAIN PROGRAM
int main(int argc, char *argv[])
{
    int num_steps = 100 * T;

//    ft = fopen("Data/trajectories.dat","w");
    startTimer(&start);
    RL_init();			//initialize interface
    initStatsCont(num_steps);	//initialize stats routine

    run(num_steps);		//run experiment	
            
    endStatsCont();		//end stats collection
    endTimer(&stop);

    printTimeTaken();
    RL_cleanup();
//    fclose(ft);
    graph(num_steps,true);	//graph stats
}
